/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 8:01:34 PM
 * To change this template use File | Settings | File Templates.
 */
package org.microformats.hCard.factory.factory
import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
class EmailFactory extends AbstractFactory {
     public Object newInstance(FactoryBuilderSupport factoryBuilderSupport, Object name, Object value, Map map) {
         def email
        if (FactoryBuilderSupport.checkValueIsType(value, name, HCard.Email.class)) {
            email = value
        } else {
            email = new HCard.Email(map.remove("address"), map.remove("types") as String [ ])
        }

        return email
    }

     public void setParent(FactoryBuilderSupport factoryBuilderSupport, Object parent, Object child) {
        parent.emails.add(child)
    }
}