/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 7:48:12 PM
 * To change this template use File | Settings | File Templates.
 */
package org.microformats.hCard.factory.factory
import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
class GeoFactory extends AbstractFactory {
     public Object newInstance(FactoryBuilderSupport factoryBuilderSupport, Object name, Object value, Map map) {
        def geo
        if (FactoryBuilderSupport.checkValueIsType(value, name, HCard.Geolocation.class)) {
            geo = value
        } else {
            def latitude = Double.parseDouble(map.remove("latitude"))
            def longitude = Double.parseDouble(map.remove("longitude"))
            geo = new HCard.Geolocation(latitude, longitude)
        }
        return geo
    }

    public void setParent(FactoryBuilderSupport factoryBuilderSupport, Object parent, Object child) {
        parent.geo = child
    }
}