/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 21, 2008
 * Time: 7:41:20 AM
 * To change this template use File | Settings | File Templates.
 */
package org.microformats.hCard.factory.factory
import org.joda.time.Instant
import org.joda.time.DateTime
import org.joda.time.DateTimeZone
import org.codehaus.groovy.runtime.InvokerHelper
class ValueFactory extends AbstractFactory {
    def name
    public Object newInstance(FactoryBuilderSupport factoryBuilderSupport, Object name, Object value, Map map) {
        def obj
        def values = map.remove("list")
        this.name = name
        switch (name) {
            case 'tz':
                def tz = TimeZone.getTimeZone(map.remove("value"))
                obj = tz.getRawOffset()
                break
            case 'bday': case 'rev':
                if (map.value instanceof Long)
                    obj = map.remove("value")
                else if (map.value instanceof Date)
                    obj = map.remove("value").getTime()
                else if (map.value instanceof Instant || map.value instanceof DateTime)
                    obj = map.remove("value").getMillis()
                break
            case 'sortString':case 'uid':
                obj = map.remove("value")
                break
        }
        return obj
    }

    public void setParent(FactoryBuilderSupport factoryBuilderSupport, Object parent, Object child) {
        InvokerHelper.setProperty(parent, name, child)
    }

}