/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 8:19:04 PM
 * To change this template use File | Settings | File Templates.
 */
package org.microformats.hCard.factory.factory
import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
class AddressFactory extends AbstractFactory {
    public Object newInstance(FactoryBuilderSupport factoryBuilderSupport, Object name, Object value, Map map) {
        def address
        if (FactoryBuilderSupport.checkValueIsType(value, name, HCard.Address.class)) {
            address = value
        } else {
            def types = map.types ?: [ ]
            def streetAddress = map.remove("streetAddress")
            def extendedAddress = map.remove("extendedAddress") ?: ''
            def locality = map.remove("locality") ?: ''
            def postOfficeBox = map.remove("postOfficeBox") ?: ''
            def region = map.remove("region") ?: ''
            def postalCode = map.remove("postalCode") ?: ''
            def countryName = map.remove("countryName") ?: ''
            address = new HCard.Address(types, streetAddress, extendedAddress, locality,
                    postOfficeBox, region, postalCode, countryName)
        }
         
        return address
    }

    public void setParent(FactoryBuilderSupport factoryBuilderSupport, Object parent, Object child) {
        parent.adrs.add(child)
    }

}