/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 7:32:27 PM
 * To change this template use File | Settings | File Templates.
 */
package org.microformats.hCard.factory.factory
import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
class NameFactory implements Factory{

    public boolean isLeaf() {
        return false; //To change body of implemented methods use File | Settings | File Templates.
    }

    public Object newInstance(FactoryBuilderSupport factoryBuilderSupport, Object name, Object value, Map map) {
        def n
        if (FactoryBuilderSupport.checkValueIsType(value, name, HCard.Name.class)) {
            n = value
        } else {
            def familyName = map.familyName
            def givenName = map.givenName
            def additionalNames = map.additionalNames ?: [ ]
            def honorificPrefixes = map.honorificPrefixes ?: [ ]
            def honorificSuffixes = map.honorificSuffixes ?: [ ]
            n = new HCard.Name(familyName, givenName, additionalNames, honorificPrefixes, honorificSuffixes)
        }

        return n
    }

    public boolean onHandleNodeAttributes(FactoryBuilderSupport factoryBuilderSupport, Object o, Map map) {
        return false; //To change body of implemented methods use File | Settings | File Templates.
    }

    public void onNodeCompleted(FactoryBuilderSupport factoryBuilderSupport, Object o, Object o1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setParent(FactoryBuilderSupport factoryBuilderSupport, Object parent, Object child) {
        parent.n = child
        parent.fn = child.toString()
    }

    public void setChild(FactoryBuilderSupport factoryBuilderSupport, Object o, Object o1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

}